/*****************************************************************************
 * xtail command / version 1.01                                              *
 *---------------------------------------------------------------------------*
 * t@C : xtail.c                                                      *
 * Tv       : Ot@CR\[ŊĎ̂ɕ֗ȃR}h       *
 *---------------------------------------------------------------------------*
 * [usage]                                                                   *
 * > xtail Ďt@C [擪ǂݔ΂TCY]                         *
 *---------------------------------------------------------------------------*
 * [return code]                                                             *
 * 0   : [UɂvO~ꂽ (CTRL+C)                         *
 * 1   : R}hIvV                                              *
 * 2   : ݂Ȃt@Cw肳ꂽ.                                   *
 *       ܂, t@CɃANZXłȂ.                                 *
 * 255 : VXeG[(OS APĨG[)                                      *
 *****************************************************************************/

/*****************************************************************************
 * wb_t@Cǂݍ                                                    *
 *****************************************************************************/
#ifdef _WIN32
#include <windows.h>
#else
#include <unistd.h>
#include <signal.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/*****************************************************************************
 * e錾                                                              *
 *****************************************************************************/
#define ERR_PRM 1
#define ERR_NOF 2
#define ERR_SYS 255
#define SEEKFMT "------------------------------- (SEEK:%08ld) -------------------------------\n"

/*****************************************************************************
 * vg^Cv錾                                                          *
 *****************************************************************************/
void SignalEnable();                            /* ׂLɂ    *//* XC0101-001 */
void SignalDisable();                           /* VOi𖳎            *//* XC0101-001 */

#ifdef _WIN32
BOOL WINAPI HandlerRoutine(DWORD dwCtrlType);   /* VOinh֐(Win) */
BOOL WINAPI HandlerIGN(DWORD dwCtrlType);       /* Windows SIGIGN          *//* XC0101-001 */
#else
void stop_handler(int signo);                   /* VOinh֐(UNIX)*/
#endif
void sleep_msec(int msec);                      /* ~bPʂ̃X[v      */

/*****************************************************************************
 * O[oϐ                                                            *
 *****************************************************************************/
FILE *stream=NULL;                              /* ǂݍރt@C̃|C^*/

/*****************************************************************************
 * main()                                                                    *
 *****************************************************************************/
int main( int argc, char* argv[] )
{
    char    buf[10240];
    long    seekp=0;
    long    ofs=0;
    int     i;
    size_t  size;
    long    fsize,fsize_before=-1;
    int     outflg=0;
    memset( buf, 0, sizeof( buf ) );

    /* VOinho^(CTRL+CŏIɃt@CN[Yp) */
    SignalEnable();                                                            /* XC0101-001 */

    /* `FbN */
    if( argc < 2 ) {
        fprintf(stderr,"Argment error\n");
        return ERR_PRM;
    }

    /* N byte ǂݔ΂w */
    if( argc == 3 ) {
        seekp = atoi( argv[2] );
    }

    fprintf(stderr,SEEKFMT,seekp);
    outflg=1;

    /* ǂݏo[v */
    while(1) {
        /* I[v */
        stream = fopen( argv[1], "rb" );
        if( NULL==stream ) {
            /* G[͏I */
            fprintf(stderr,"File open error");
            break;
        }
        /* ߂ */
        fseek( stream, 0, SEEK_SET );
        fseek( stream, 0, SEEK_END );
        fsize = (long)ftell( stream );
        if(fsize>=fsize_before) {
            /* ǂݏoʒuݒ */
            if(fseek(stream,seekp+ofs,SEEK_SET)!=0) {
                /* ݒłȂΐ擪ɐݒ */
                if(outflg==0) {
                    fprintf(stderr,SEEKFMT,seekp);
                    outflg=1;
                }
                fseek(stream,seekp,SEEK_SET);
                ofs=0;
            }
        } else {
            /* ÔŐ擪ɐݒ */
            if(outflg==0) {
                fprintf(stderr,SEEKFMT,seekp);
                outflg=1;
            }
            fseek(stream,seekp,SEEK_SET);
            ofs=0;
        }
        fsize_before=fsize;

        /* ǂݍ݁`\ */
        memset( buf, 0, sizeof( buf ) );
        if( (size=fread( buf, 1, sizeof(buf), stream )) != 0 ) {
            /* ǂݍ݃f[^ */
            fprintf( stdout, "%s", buf );
            ofs+=size;
            SignalDisable();			/* ꎞIɃVOi𖳌ɂ */     /* XC0101-001 */
            fclose(stream);
            stream=NULL;
            SignalEnable();				/* VOiLɂ */             /* XC0101-001 */
            outflg=0;
        } else {
            /* f[^ꍇ́A10ms wait */
            SignalDisable();			/* ꎞIɃVOi𖳌ɂ */     /* XC0101-001 */
            fclose(stream);
            stream=NULL;
            SignalEnable();				/* VOiLɂ */             /* XC0101-001 */
            sleep_msec(10);
        }
    }

    /* t@CI[vŝ݂Ń^[ */
    return ERR_NOF;
}

/*****************************************************************************
 * XC0101-001 ŐVKǉ                                                   *
 * SignalEnable()                                                            *
 * - VOinhLɂ                                            *
 *****************************************************************************/
void SignalEnable()
{
    /* VOinho^(CTRL+CŏIɃt@CN[Yp) */
#ifdef _WIN32
    if(SetConsoleCtrlHandler(HandlerRoutine, TRUE)==FALSE) {
        fprintf(stderr,"System error" );
        exit(ERR_SYS);
    }
#else
    signal(SIGINT,stop_handler);
    signal(SIGTERM,stop_handler);
#endif
	return;
}

/*****************************************************************************
 * XC0101-001 ŐVKǉ                                                   *
 * SignalDisable()                                                           *
 * - VOi𖳎                                                      *
 *****************************************************************************/
void SignalDisable()
{
    /* VOi𖳎 */
#ifdef _WIN32
    if(SetConsoleCtrlHandler(HandlerIGN, TRUE)==FALSE) {
        fprintf(stderr,"System error" );
        exit(ERR_SYS);
    }
#else
    signal(SIGINT,SIG_IGN);
    signal(SIGTERM,SIG_IGN);
#endif
	return;
}

/*****************************************************************************
 * HandlerRoutine()                                                          *
 * - Windows VOinh֐                                            *
 * - ߂l0exitɂ悤ɏC                                           *
 * - G[sbg͓ɖ̂ŊO                            *
 *****************************************************************************/
#ifdef _WIN32
BOOL WINAPI HandlerRoutine(DWORD dwCtrlType)
{
    switch(dwCtrlType) {
    case CTRL_C_EVENT:
    case CTRL_BREAK_EVENT:
    case CTRL_CLOSE_EVENT:
    case CTRL_LOGOFF_EVENT:
    case CTRL_SHUTDOWN_EVENT:
        /* t@CN[YRh~ */
        if(stream) {
            fclose(stream);
        }
        fprintf(stdout,"\n");                                                  /* XC0101-002 */
        fprintf(stderr,"*******************\n");
        fprintf(stderr,"* STOPPED BY USER *\n");
        fprintf(stderr,"*******************\n");
        exit(0);
    default:
        break;
    }

    return TRUE;
}

/*****************************************************************************
 * XC0101-001 ŐVKǉ                                                   *
 * HandlerRoutineIGN()                                                       *
 * - ׂẴRg[𖳎                                          *
 * - Windows  SIGIGN Ǝ悤ȓVOinh֐            *
 *****************************************************************************/
BOOL WINAPI HandlerIGN(DWORD dwCtrlType)
{
    return TRUE;
}

#else
/*****************************************************************************
 * stop_handler()                                                            *
 * - UNIX VOinh֐                                               *
 * - G[sbg͓ɖ̂ŊO                            *
 * - exitVOiZ[t(_exit)ɏC                                       *
 *****************************************************************************/
void stop_handler(int signo)
{
    /* t@CN[YRh~ */
    if(stream) {
        fclose(stream);
    }
    fprintf(stdout,"\n");                                                      /* XC0101-002 */
    fprintf(stderr,"*******************\n");
    fprintf(stderr,"* STOPPED BY USER *\n");
    fprintf(stderr,"*******************\n");
    _exit(0);
}
#endif

/*****************************************************************************
 * sleep_msec()                                                              *
 * - ~bԂ̃XbhX[vs                                        *
 * - G[sbg͓ɖ̂ŊO                            *
 *****************************************************************************/
void sleep_msec(int t)
{
#ifdef _WIN32
    /* ===== Windows̏ꍇ ===== */
    Sleep(t);
#else
    /* ===== UNIX̏ꍇ ===== */
    struct timeval timeoutRec;
    timeoutRec.tv_sec = t/1000;
    timeoutRec.tv_usec = (t % 1000)*1000;
    select(0, NULL, NULL, NULL, &timeoutRec);
#endif
}

/* End of xtail.c */
